import{S as Ms,i as zs,s as Cs,e as t,k as m,w as _,t as n,M as qs,c as a,d as o,m as c,a as s,x as b,h as i,b as p,G as e,g,y as v,q as y,o as $,B as x,v as Ls,L as Ds}from"../../chunks/vendor-hf-doc-builder.js";import{T as js}from"../../chunks/Tip-hf-doc-builder.js";import{D as P}from"../../chunks/Docstring-hf-doc-builder.js";import{C as ks}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as Na}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Ts}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Ns(Q){let f,T,I,h,D;return h=new ks({props:{code:`# We can't instantiate directly the base class *ImageProcessingMixin* so let's show the examples on a
# derived class: *CLIPImageProcessor*
image_processor = CLIPImageProcessor.from_pretrained(
    "openai/clip-vit-base-patch32"
)  # Download image_processing_config from huggingface.co and cache.
image_processor = CLIPImageProcessor.from_pretrained(
    "./test/saved_model/"
)  # E.g. image processor (or model) was saved using *save_pretrained('./test/saved_model/')*
image_processor = CLIPImageProcessor.from_pretrained("./test/saved_model/preprocessor_config.json")
image_processor = CLIPImageProcessor.from_pretrained(
    "openai/clip-vit-base-patch32", do_normalize=False, foo=False
)
assert image_processor.do_normalize is False
image_processor, unused_kwargs = CLIPImageProcessor.from_pretrained(
    "openai/clip-vit-base-patch32", do_normalize=False, foo=False, return_unused_kwargs=True
)
assert image_processor.do_normalize is False
assert unused_kwargs == {"foo": False}`,highlighted:`<span class="hljs-comment"># We can&#x27;t instantiate directly the base class *ImageProcessingMixin* so let&#x27;s show the examples on a</span>
<span class="hljs-comment"># derived class: *CLIPImageProcessor*</span>
image_processor = CLIPImageProcessor.from_pretrained(
    <span class="hljs-string">&quot;openai/clip-vit-base-patch32&quot;</span>
)  <span class="hljs-comment"># Download image_processing_config from huggingface.co and cache.</span>
image_processor = CLIPImageProcessor.from_pretrained(
    <span class="hljs-string">&quot;./test/saved_model/&quot;</span>
)  <span class="hljs-comment"># E.g. image processor (or model) was saved using *save_pretrained(&#x27;./test/saved_model/&#x27;)*</span>
image_processor = CLIPImageProcessor.from_pretrained(<span class="hljs-string">&quot;./test/saved_model/preprocessor_config.json&quot;</span>)
image_processor = CLIPImageProcessor.from_pretrained(
    <span class="hljs-string">&quot;openai/clip-vit-base-patch32&quot;</span>, do_normalize=<span class="hljs-literal">False</span>, foo=<span class="hljs-literal">False</span>
)
<span class="hljs-keyword">assert</span> image_processor.do_normalize <span class="hljs-keyword">is</span> <span class="hljs-literal">False</span>
image_processor, unused_kwargs = CLIPImageProcessor.from_pretrained(
    <span class="hljs-string">&quot;openai/clip-vit-base-patch32&quot;</span>, do_normalize=<span class="hljs-literal">False</span>, foo=<span class="hljs-literal">False</span>, return_unused_kwargs=<span class="hljs-literal">True</span>
)
<span class="hljs-keyword">assert</span> image_processor.do_normalize <span class="hljs-keyword">is</span> <span class="hljs-literal">False</span>
<span class="hljs-keyword">assert</span> unused_kwargs == {<span class="hljs-string">&quot;foo&quot;</span>: <span class="hljs-literal">False</span>}`}}),{c(){f=t("p"),T=n("Examples:"),I=m(),_(h.$$.fragment)},l(l){f=a(l,"P",{});var E=s(f);T=i(E,"Examples:"),E.forEach(o),I=c(l),b(h.$$.fragment,l)},m(l,E){g(l,f,E),e(f,T),g(l,I,E),v(h,l,E),D=!0},p:Ds,i(l){D||(y(h.$$.fragment,l),D=!0)},o(l){$(h.$$.fragment,l),D=!1},d(l){l&&o(f),l&&o(I),x(h,l)}}}function Os(Q){let f,T,I,h,D;return h=new ks({props:{code:`from transformers import AutoImageProcessor

image processor = AutoImageProcessor.from_pretrained("bert-base-cased")

# Push the image processor to your namespace with the name "my-finetuned-bert".
image processor.push_to_hub("my-finetuned-bert")

# Push the image processor to an organization with the name "my-finetuned-bert".
image processor.push_to_hub("huggingface/my-finetuned-bert")`,highlighted:`<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor

image processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;bert-base-cased&quot;</span>)

<span class="hljs-comment"># Push the image processor to your namespace with the name &quot;my-finetuned-bert&quot;.</span>
image processor.push_to_hub(<span class="hljs-string">&quot;my-finetuned-bert&quot;</span>)

<span class="hljs-comment"># Push the image processor to an organization with the name &quot;my-finetuned-bert&quot;.</span>
image processor.push_to_hub(<span class="hljs-string">&quot;huggingface/my-finetuned-bert&quot;</span>)`}}),{c(){f=t("p"),T=n("Examples:"),I=m(),_(h.$$.fragment)},l(l){f=a(l,"P",{});var E=s(f);T=i(E,"Examples:"),E.forEach(o),I=c(l),b(h.$$.fragment,l)},m(l,E){g(l,f,E),e(f,T),g(l,I,E),v(h,l,E),D=!0},p:Ds,i(l){D||(y(h.$$.fragment,l),D=!0)},o(l){$(h.$$.fragment,l),D=!1},d(l){l&&o(f),l&&o(I),x(h,l)}}}function As(Q){let f,T;return{c(){f=t("p"),T=n("This API is experimental and may have some slight breaking changes in the next releases.")},l(I){f=a(I,"P",{});var h=s(f);T=i(h,"This API is experimental and may have some slight breaking changes in the next releases."),h.forEach(o)},m(I,h){g(I,f,h),e(f,T)},d(I){I&&o(f)}}}function Ss(Q){let f,T,I,h,D,l,E,sr,Do,Vr,We,ko,Wr,Je,Mo,Jr,S,X,nr,fe,zo,ir,Co,Br,F,he,qo,k,Lo,mr,jo,No,cr,Oo,Ao,dr,So,Fo,Hr,M,ue,Uo,lr,Ro,Vo,pr,Wo,Gr,z,_e,Jo,gr,Bo,Ho,fr,Go,Yr,U,be,Yo,hr,Ko,Kr,C,ve,Qo,q,Xo,ur,Zo,et,_r,rt,ot,br,tt,at,st,vr,nt,Qr,R,ye,it,L,mt,yr,ct,dt,$r,lt,pt,xr,gt,ft,Xr,V,$e,ht,Ir,ut,Zr,W,xe,_t,J,bt,wr,vt,yt,Pr,$t,xt,eo,B,Ie,It,H,wt,Er,Pt,Et,Tr,Tt,Dt,ro,G,we,kt,Pe,Mt,Dr,zt,Ct,oo,Y,Z,kr,Ee,qt,Mr,Lt,to,u,Te,jt,zr,Nt,Ot,ee,De,At,ke,St,Be,Ft,Ut,Rt,re,Me,Vt,ze,Wt,He,Jt,Bt,Ht,N,Ce,Gt,qe,Yt,Ge,Kt,Qt,Xt,oe,Zt,te,Le,ea,j,ra,Cr,oa,ta,qr,aa,sa,Lr,na,ia,ma,O,je,ca,Ne,da,jr,la,pa,ga,ae,fa,A,Oe,ha,Ae,ua,Nr,_a,ba,va,se,ya,ne,Se,$a,K,xa,Or,Ia,wa,Ye,Pa,Ea,Ta,ie,Fe,Da,Ar,ka,Ma,me,Ue,za,Sr,Ca,qa,ce,Re,La,Fr,ja,ao;return l=new Na({}),fe=new Na({}),he=new P({props:{name:"transformers.image_transforms.center_crop",anchor:"transformers.image_transforms.center_crop",parameters:[{name:"image",val:": ndarray"},{name:"size",val:": typing.Tuple[int, int]"},{name:"data_format",val:": typing.Union[str, transformers.image_utils.ChannelDimension, NoneType] = None"},{name:"return_numpy",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.image_transforms.center_crop.image",description:`<strong>image</strong> (<code>np.ndarray</code>) &#x2014;
The image to crop.`,name:"image"},{anchor:"transformers.image_transforms.center_crop.size",description:`<strong>size</strong> (<code>Tuple[int, int]</code>) &#x2014;
The target size for the cropped image.`,name:"size"},{anchor:"transformers.image_transforms.center_crop.data_format",description:`<strong>data_format</strong> (<code>str</code> or <code>ChannelDimension</code>, <em>optional</em>) &#x2014;
The channel dimension format for the output image. Can be one of:<ul>
<li><code>&quot;channels_first&quot;</code> or <code>ChannelDimension.FIRST</code>: image in (num_channels, height, width) format.</li>
<li><code>&quot;channels_last&quot;</code> or <code>ChannelDimension.LAST</code>: image in (height, width, num_channels) format.
If unset, will use the inferred format of the input image.</li>
</ul>`,name:"data_format"},{anchor:"transformers.image_transforms.center_crop.return_numpy",description:`<strong>return_numpy</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the cropped image as a numpy array. Used for backwards compatibility with the
previous ImageFeatureExtractionMixin method.<ul>
<li>Unset: will return the same type as the input image.</li>
<li><code>True</code>: will return a numpy array.</li>
<li><code>False</code>: will return a <code>PIL.Image.Image</code> object.</li>
</ul>`,name:"return_numpy"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/image_transforms.py#L335",returnDescription:`
<p>The cropped image.</p>
`,returnType:`
<p><code>np.ndarray</code></p>
`}}),ue=new P({props:{name:"transformers.image_transforms.center_to_corners_format",anchor:"transformers.image_transforms.center_to_corners_format",parameters:[{name:"bboxes_center",val:": TensorType"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/image_transforms.py#L461"}}),_e=new P({props:{name:"transformers.image_transforms.corners_to_center_format",anchor:"transformers.image_transforms.corners_to_center_format",parameters:[{name:"bboxes_corners",val:": TensorType"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/image_transforms.py#L521"}}),be=new P({props:{name:"transformers.image_transforms.id_to_rgb",anchor:"transformers.image_transforms.id_to_rgb",parameters:[{name:"id_map",val:""}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/image_transforms.py#L555"}}),ve=new P({props:{name:"transformers.image_transforms.normalize",anchor:"transformers.image_transforms.normalize",parameters:[{name:"image",val:": ndarray"},{name:"mean",val:": typing.Union[float, typing.Iterable[float]]"},{name:"std",val:": typing.Union[float, typing.Iterable[float]]"},{name:"data_format",val:": typing.Optional[transformers.image_utils.ChannelDimension] = None"}],parametersDescription:[{anchor:"transformers.image_transforms.normalize.image",description:`<strong>image</strong> (<code>np.ndarray</code>) &#x2014;
The image to normalize.`,name:"image"},{anchor:"transformers.image_transforms.normalize.mean",description:`<strong>mean</strong> (<code>float</code> or <code>Iterable[float]</code>) &#x2014;
The mean to use for normalization.`,name:"mean"},{anchor:"transformers.image_transforms.normalize.std",description:`<strong>std</strong> (<code>float</code> or <code>Iterable[float]</code>) &#x2014;
The standard deviation to use for normalization.`,name:"std"},{anchor:"transformers.image_transforms.normalize.data_format",description:`<strong>data_format</strong> (<code>ChannelDimension</code>, <em>optional</em>) &#x2014;
The channel dimension format of the output image. If <code>None</code>, will use the inferred format from the input.`,name:"data_format"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/image_transforms.py#L274"}}),ye=new P({props:{name:"transformers.image_transforms.pad",anchor:"transformers.image_transforms.pad",parameters:[{name:"image",val:": ndarray"},{name:"padding",val:": typing.Union[int, typing.Tuple[int, int], typing.Iterable[typing.Tuple[int, int]]]"},{name:"mode",val:": PaddingMode = <PaddingMode.CONSTANT: 'constant'>"},{name:"constant_values",val:": typing.Union[float, typing.Iterable[float]] = 0.0"},{name:"data_format",val:": typing.Union[str, transformers.image_utils.ChannelDimension, NoneType] = None"},{name:"input_data_format",val:": typing.Union[str, transformers.image_utils.ChannelDimension, NoneType] = None"}],parametersDescription:[{anchor:"transformers.image_transforms.pad.image",description:`<strong>image</strong> (<code>np.ndarray</code>) &#x2014;
The image to pad.`,name:"image"},{anchor:"transformers.image_transforms.pad.padding",description:`<strong>padding</strong> (<code>int</code> or <code>Tuple[int, int]</code> or <code>Iterable[Tuple[int, int]]</code>) &#x2014;
Padding to apply to the edges of the height, width axes. Can be one of three formats:<ul>
<li><code>((before_height, after_height), (before_width, after_width))</code> unique pad widths for each axis.</li>
<li><code>((before, after),)</code> yields same before and after pad for height and width.</li>
<li><code>(pad,)</code> or int is a shortcut for before = after = pad width for all axes.</li>
</ul>`,name:"padding"},{anchor:"transformers.image_transforms.pad.mode",description:`<strong>mode</strong> (<code>PaddingMode</code>) &#x2014;
The padding mode to use. Can be one of:<ul>
<li><code>&quot;constant&quot;</code>: pads with a constant value.</li>
<li><code>&quot;reflect&quot;</code>: pads with the reflection of the vector mirrored on the first and last values of the
vector along each axis.</li>
<li><code>&quot;replicate&quot;</code>: pads with the replication of the last value on the edge of the array along each axis.</li>
<li><code>&quot;symmetric&quot;</code>: pads with the reflection of the vector mirrored along the edge of the array.</li>
</ul>`,name:"mode"},{anchor:"transformers.image_transforms.pad.constant_values",description:`<strong>constant_values</strong> (<code>float</code> or <code>Iterable[float]</code>, <em>optional</em>) &#x2014;
The value to use for the padding if <code>mode</code> is <code>&quot;constant&quot;</code>.`,name:"constant_values"},{anchor:"transformers.image_transforms.pad.data_format",description:`<strong>data_format</strong> (<code>str</code> or <code>ChannelDimension</code>, <em>optional</em>) &#x2014;
The channel dimension format for the output image. Can be one of:<ul>
<li><code>&quot;channels_first&quot;</code> or <code>ChannelDimension.FIRST</code>: image in (num_channels, height, width) format.</li>
<li><code>&quot;channels_last&quot;</code> or <code>ChannelDimension.LAST</code>: image in (height, width, num_channels) format.
If unset, will use same as the input image.</li>
</ul>`,name:"data_format"},{anchor:"transformers.image_transforms.pad.input_data_format",description:`<strong>input_data_format</strong> (<code>str</code> or <code>ChannelDimension</code>, <em>optional</em>) &#x2014;
The channel dimension format for the input image. Can be one of:<ul>
<li><code>&quot;channels_first&quot;</code> or <code>ChannelDimension.FIRST</code>: image in (num_channels, height, width) format.</li>
<li><code>&quot;channels_last&quot;</code> or <code>ChannelDimension.LAST</code>: image in (height, width, num_channels) format.
If unset, will use the inferred format of the input image.</li>
</ul>`,name:"input_data_format"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/image_transforms.py#L585",returnDescription:`
<p>The padded image.</p>
`,returnType:`
<p><code>np.ndarray</code></p>
`}}),$e=new P({props:{name:"transformers.image_transforms.rgb_to_id",anchor:"transformers.image_transforms.rgb_to_id",parameters:[{name:"color",val:""}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/image_transforms.py#L544"}}),xe=new P({props:{name:"transformers.rescale",anchor:"transformers.rescale",parameters:[{name:"image",val:": ndarray"},{name:"scale",val:": float"},{name:"data_format",val:": typing.Optional[transformers.image_utils.ChannelDimension] = None"},{name:"dtype",val:" = <class 'numpy.float32'>"}],parametersDescription:[{anchor:"transformers.rescale.image",description:`<strong>image</strong> (<code>np.ndarray</code>) &#x2014;
The image to rescale.`,name:"image"},{anchor:"transformers.rescale.scale",description:`<strong>scale</strong> (<code>float</code>) &#x2014;
The scale to use for rescaling the image.`,name:"scale"},{anchor:"transformers.rescale.data_format",description:`<strong>data_format</strong> (<code>ChannelDimension</code>, <em>optional</em>) &#x2014;
The channel dimension format of the image. If not provided, it will be the same as the input image.`,name:"data_format"},{anchor:"transformers.rescale.dtype",description:`<strong>dtype</strong> (<code>np.dtype</code>, <em>optional</em>, defaults to <code>np.float32</code>) &#x2014;
The dtype of the output image. Defaults to <code>np.float32</code>. Used for backwards compatibility with feature
extractors.`,name:"dtype"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/image_transforms.py#L82",returnDescription:`
<p>The rescaled image.</p>
`,returnType:`
<p><code>np.ndarray</code></p>
`}}),Ie=new P({props:{name:"transformers.resize",anchor:"transformers.resize",parameters:[{name:"image",val:""},{name:"size",val:": typing.Tuple[int, int]"},{name:"resample",val:" = <Resampling.BILINEAR: 2>"},{name:"data_format",val:": typing.Optional[transformers.image_utils.ChannelDimension] = None"},{name:"return_numpy",val:": bool = True"}],parametersDescription:[{anchor:"transformers.resize.image",description:`<strong>image</strong> (<code>PIL.Image.Image</code> or <code>np.ndarray</code> or <code>torch.Tensor</code>) &#x2014;
The image to resize.`,name:"image"},{anchor:"transformers.resize.size",description:`<strong>size</strong> (<code>Tuple[int, int]</code>) &#x2014;
The size to use for resizing the image.`,name:"size"},{anchor:"transformers.resize.resample",description:`<strong>resample</strong> (<code>int</code>, <em>optional</em>, defaults to <code>PILImageResampling.BILINEAR</code>) &#x2014;
The filter to user for resampling.`,name:"resample"},{anchor:"transformers.resize.data_format",description:`<strong>data_format</strong> (<code>ChannelDimension</code>, <em>optional</em>) &#x2014;
The channel dimension format of the output image. If <code>None</code>, will use the inferred format from the input.`,name:"data_format"},{anchor:"transformers.resize.return_numpy",description:`<strong>return_numpy</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return the resized image as a numpy array. If False a <code>PIL.Image.Image</code> object is
returned.`,name:"return_numpy"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/image_transforms.py#L222",returnDescription:`
<p>The resized image.</p>
`,returnType:`
<p><code>np.ndarray</code></p>
`}}),we=new P({props:{name:"transformers.to_pil_image",anchor:"transformers.to_pil_image",parameters:[{name:"image",val:": typing.Union[numpy.ndarray, PIL.Image.Image, ForwardRef('torch.Tensor'), ForwardRef('tf.Tensor'), ForwardRef('jnp.ndarray')]"},{name:"do_rescale",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.to_pil_image.image",description:`<strong>image</strong> (<code>PIL.Image.Image</code> or <code>numpy.ndarray</code> or <code>torch.Tensor</code> or <code>tf.Tensor</code>) &#x2014;
The image to convert to the <code>PIL.Image</code> format.`,name:"image"},{anchor:"transformers.to_pil_image.do_rescale",description:`<strong>do_rescale</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to apply the scaling factor (to make pixel values integers between 0 and 255). Will default
to <code>True</code> if the image type is a floating type, <code>False</code> otherwise.`,name:"do_rescale"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/image_transforms.py#L112",returnDescription:`
<p>The converted image.</p>
`,returnType:`
<p><code>PIL.Image.Image</code></p>
`}}),Ee=new Na({}),Te=new P({props:{name:"class transformers.ImageProcessingMixin",anchor:"transformers.ImageProcessingMixin",parameters:[{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/image_processing_utils.py#L58"}}),De=new P({props:{name:"from_dict",anchor:"transformers.ImageProcessingMixin.from_dict",parameters:[{name:"image_processor_dict",val:": typing.Dict[str, typing.Any]"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.ImageProcessingMixin.from_dict.image_processor_dict",description:`<strong>image_processor_dict</strong> (<code>Dict[str, Any]</code>) &#x2014;
Dictionary that will be used to instantiate the image processor object. Such a dictionary can be
retrieved from a pretrained checkpoint by leveraging the
<a href="/docs/transformers/main/en/internal/image_processing_utils#transformers.ImageProcessingMixin.to_dict">to_dict()</a> method.`,name:"image_processor_dict"},{anchor:"transformers.ImageProcessingMixin.from_dict.kwargs",description:`<strong>kwargs</strong> (<code>Dict[str, Any]</code>) &#x2014;
Additional parameters from which to initialize the image processor object.`,name:"kwargs"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/image_processing_utils.py#L302",returnDescription:`
<p>The image processor object instantiated from those
parameters.</p>
`,returnType:`
<p><a
  href="/docs/transformers/main/en/internal/image_processing_utils#transformers.ImageProcessingMixin"
>ImageProcessingMixin</a></p>
`}}),Me=new P({props:{name:"from_json_file",anchor:"transformers.ImageProcessingMixin.from_json_file",parameters:[{name:"json_file",val:": typing.Union[str, os.PathLike]"}],parametersDescription:[{anchor:"transformers.ImageProcessingMixin.from_json_file.json_file",description:`<strong>json_file</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Path to the JSON file containing the parameters.`,name:"json_file"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/image_processing_utils.py#L350",returnDescription:`
<p>The image_processor object
instantiated from that JSON file.</p>
`,returnType:`
<p>A image processor of type <a
  href="/docs/transformers/main/en/internal/image_processing_utils#transformers.ImageProcessingMixin"
>ImageProcessingMixin</a></p>
`}}),Ce=new P({props:{name:"from_pretrained",anchor:"transformers.ImageProcessingMixin.from_pretrained",parameters:[{name:"pretrained_model_name_or_path",val:": typing.Union[str, os.PathLike]"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.ImageProcessingMixin.from_pretrained.pretrained_model_name_or_path",description:`<strong>pretrained_model_name_or_path</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
This can be either:</p>
<ul>
<li>a string, the <em>model id</em> of a pretrained image_processor hosted inside a model repo on
huggingface.co. Valid model ids can be located at the root-level, like <code>bert-base-uncased</code>, or
namespaced under a user or organization name, like <code>dbmdz/bert-base-german-cased</code>.</li>
<li>a path to a <em>directory</em> containing a image processor file saved using the
<a href="/docs/transformers/main/en/internal/image_processing_utils#transformers.ImageProcessingMixin.save_pretrained">save_pretrained()</a> method, e.g.,
<code>./my_model_directory/</code>.</li>
<li>a path or url to a saved image processor JSON <em>file</em>, e.g.,
<code>./my_model_directory/preprocessor_config.json</code>.</li>
</ul>`,name:"pretrained_model_name_or_path"},{anchor:"transformers.ImageProcessingMixin.from_pretrained.cache_dir",description:`<strong>cache_dir</strong> (<code>str</code> or <code>os.PathLike</code>, <em>optional</em>) &#x2014;
Path to a directory in which a downloaded pretrained model image processor should be cached if the
standard cache should not be used.`,name:"cache_dir"},{anchor:"transformers.ImageProcessingMixin.from_pretrained.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to force to (re-)download the image processor files and override the cached versions if
they exist.`,name:"force_download"},{anchor:"transformers.ImageProcessingMixin.from_pretrained.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to delete incompletely received file. Attempts to resume the download if such a file
exists.`,name:"resume_download"},{anchor:"transformers.ImageProcessingMixin.from_pretrained.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint, e.g., <code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}.</code> The proxies are used on each request.`,name:"proxies"},{anchor:"transformers.ImageProcessingMixin.from_pretrained.use_auth_token",description:`<strong>use_auth_token</strong> (<code>str</code> or <code>bool</code>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If <code>True</code>, or not specified, will use
the token generated when running <code>huggingface-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"use_auth_token"},{anchor:"transformers.ImageProcessingMixin.from_pretrained.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;main&quot;</code>) &#x2014;
The specific model version to use. It can be a branch name, a tag name, or a commit id, since we use a
git-based system for storing models and other artifacts on huggingface.co, so <code>revision</code> can be any
identifier allowed by git.`,name:"revision"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/image_processing_utils.py#L82",returnDescription:`
<p>A image processor of type <a
  href="/docs/transformers/main/en/internal/image_processing_utils#transformers.ImageProcessingMixin"
>ImageProcessingMixin</a>.</p>
`}}),oe=new Ts({props:{anchor:"transformers.ImageProcessingMixin.from_pretrained.example",$$slots:{default:[Ns]},$$scope:{ctx:Q}}}),Le=new P({props:{name:"get_image_processor_dict",anchor:"transformers.ImageProcessingMixin.get_image_processor_dict",parameters:[{name:"pretrained_model_name_or_path",val:": typing.Union[str, os.PathLike]"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.ImageProcessingMixin.get_image_processor_dict.pretrained_model_name_or_path",description:`<strong>pretrained_model_name_or_path</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
The identifier of the pre-trained checkpoint from which we want the dictionary of parameters.`,name:"pretrained_model_name_or_path"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/image_processing_utils.py#L209",returnDescription:`
<p>The dictionary(ies) that will be used to instantiate the image processor object.</p>
`,returnType:`
<p><code>Tuple[Dict, Dict]</code></p>
`}}),je=new P({props:{name:"push_to_hub",anchor:"transformers.ImageProcessingMixin.push_to_hub",parameters:[{name:"repo_id",val:": str"},{name:"use_temp_dir",val:": typing.Optional[bool] = None"},{name:"commit_message",val:": typing.Optional[str] = None"},{name:"private",val:": typing.Optional[bool] = None"},{name:"use_auth_token",val:": typing.Union[bool, str, NoneType] = None"},{name:"max_shard_size",val:": typing.Union[int, str, NoneType] = '10GB'"},{name:"create_pr",val:": bool = False"},{name:"**deprecated_kwargs",val:""}],parametersDescription:[{anchor:"transformers.ImageProcessingMixin.push_to_hub.repo_id",description:`<strong>repo_id</strong> (<code>str</code>) &#x2014;
The name of the repository you want to push your image processor to. It should contain your organization name
when pushing to a given organization.`,name:"repo_id"},{anchor:"transformers.ImageProcessingMixin.push_to_hub.use_temp_dir",description:`<strong>use_temp_dir</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to use a temporary directory to store the files saved before they are pushed to the Hub.
Will default to <code>True</code> if there is no directory named like <code>repo_id</code>, <code>False</code> otherwise.`,name:"use_temp_dir"},{anchor:"transformers.ImageProcessingMixin.push_to_hub.commit_message",description:`<strong>commit_message</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Message to commit while pushing. Will default to <code>&quot;Upload image processor&quot;</code>.`,name:"commit_message"},{anchor:"transformers.ImageProcessingMixin.push_to_hub.private",description:`<strong>private</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not the repository created should be private.`,name:"private"},{anchor:"transformers.ImageProcessingMixin.push_to_hub.use_auth_token",description:`<strong>use_auth_token</strong> (<code>bool</code> or <code>str</code>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If <code>True</code>, will use the token generated
when running <code>huggingface-cli login</code> (stored in <code>~/.huggingface</code>). Will default to <code>True</code> if <code>repo_url</code>
is not specified.`,name:"use_auth_token"},{anchor:"transformers.ImageProcessingMixin.push_to_hub.max_shard_size",description:`<strong>max_shard_size</strong> (<code>int</code> or <code>str</code>, <em>optional</em>, defaults to <code>&quot;10GB&quot;</code>) &#x2014;
Only applicable for models. The maximum size for a checkpoint before being sharded. Checkpoints shard
will then be each of size lower than this size. If expressed as a string, needs to be digits followed
by a unit (like <code>&quot;5MB&quot;</code>).`,name:"max_shard_size"},{anchor:"transformers.ImageProcessingMixin.push_to_hub.create_pr",description:`<strong>create_pr</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to create a PR with the uploaded files or directly commit.`,name:"create_pr"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/utils/hub.py#L712"}}),ae=new Ts({props:{anchor:"transformers.ImageProcessingMixin.push_to_hub.example",$$slots:{default:[Os]},$$scope:{ctx:Q}}}),Oe=new P({props:{name:"register_for_auto_class",anchor:"transformers.ImageProcessingMixin.register_for_auto_class",parameters:[{name:"auto_class",val:" = 'AutoImageProcessor'"}],parametersDescription:[{anchor:"transformers.ImageProcessingMixin.register_for_auto_class.auto_class",description:`<strong>auto_class</strong> (<code>str</code> or <code>type</code>, <em>optional</em>, defaults to <code>&quot;AutoImageProcessor &quot;</code>) &#x2014;
The auto class to register this new image processor with.`,name:"auto_class"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/image_processing_utils.py#L404"}}),se=new js({props:{warning:!0,$$slots:{default:[As]},$$scope:{ctx:Q}}}),Se=new P({props:{name:"save_pretrained",anchor:"transformers.ImageProcessingMixin.save_pretrained",parameters:[{name:"save_directory",val:": typing.Union[str, os.PathLike]"},{name:"push_to_hub",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.ImageProcessingMixin.save_pretrained.save_directory",description:`<strong>save_directory</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Directory where the image processor JSON file will be saved (will be created if it does not exist).`,name:"save_directory"},{anchor:"transformers.ImageProcessingMixin.save_pretrained.push_to_hub",description:`<strong>push_to_hub</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to push your model to the Hugging Face model hub after saving it. You can specify the
repository you want to push to with <code>repo_id</code> (will default to the name of <code>save_directory</code> in your
namespace).
kwargs &#x2014;
Additional key word arguments passed along to the <a href="/docs/transformers/main/en/internal/image_processing_utils#transformers.ImageProcessingMixin.push_to_hub">push_to_hub()</a> method.`,name:"push_to_hub"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/image_processing_utils.py#L165"}}),Fe=new P({props:{name:"to_dict",anchor:"transformers.ImageProcessingMixin.to_dict",parameters:[],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/image_processing_utils.py#L338",returnDescription:`
<p>Dictionary of all the attributes that make up this image processor instance.</p>
`,returnType:`
<p><code>Dict[str, Any]</code></p>
`}}),Ue=new P({props:{name:"to_json_file",anchor:"transformers.ImageProcessingMixin.to_json_file",parameters:[{name:"json_file_path",val:": typing.Union[str, os.PathLike]"}],parametersDescription:[{anchor:"transformers.ImageProcessingMixin.to_json_file.json_file_path",description:`<strong>json_file_path</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Path to the JSON file in which this image_processor instance&#x2019;s parameters will be saved.`,name:"json_file_path"}],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/image_processing_utils.py#L390"}}),Re=new P({props:{name:"to_json_string",anchor:"transformers.ImageProcessingMixin.to_json_string",parameters:[],source:"https://github.com/huggingface/transformers/blob/main/src/transformers/image_processing_utils.py#L369",returnDescription:`
<p>String containing all the attributes that make up this feature_extractor instance in JSON format.</p>
`,returnType:`
<p><code>str</code></p>
`}}),{c(){f=t("meta"),T=m(),I=t("h1"),h=t("a"),D=t("span"),_(l.$$.fragment),E=m(),sr=t("span"),Do=n("Utilities for Image Processors"),Vr=m(),We=t("p"),ko=n(`This page lists all the utility functions used by the image processors, mainly the functional
transformations used to process the images.`),Wr=m(),Je=t("p"),Mo=n("Most of those are only useful if you are studying the code of the image processors in the library."),Jr=m(),S=t("h2"),X=t("a"),nr=t("span"),_(fe.$$.fragment),zo=m(),ir=t("span"),Co=n("Image Transformations"),Br=m(),F=t("div"),_(he.$$.fragment),qo=m(),k=t("p"),Lo=n("Crops the "),mr=t("code"),jo=n("image"),No=n(" to the specified "),cr=t("code"),Oo=n("size"),Ao=n(` using a center crop. Note that if the image is too small to be cropped to
the size given, it will be padded (so the returned result will always be of size `),dr=t("code"),So=n("size"),Fo=n(")."),Hr=m(),M=t("div"),_(ue.$$.fragment),Uo=m(),lr=t("p"),Ro=n("Converts bounding boxes from center format to corners format."),Vo=m(),pr=t("p"),Wo=n(`center format: contains the coordinate for the center of the box and its width, height dimensions
(center_x, center_y, width, height)
corners format: contains the coodinates for the top-left and bottom-right corners of the box
(top_left_x, top_left_y, bottom_right_x, bottom_right_y)`),Gr=m(),z=t("div"),_(_e.$$.fragment),Jo=m(),gr=t("p"),Bo=n("Converts bounding boxes from corners format to center format."),Ho=m(),fr=t("p"),Go=n(`corners format: contains the coodinates for the top-left and bottom-right corners of the box
(top_left_x, top_left_y, bottom_right_x, bottom_right_y)
center format: contains the coordinate for the center of the box and its the width, height dimensions
(center_x, center_y, width, height)`),Yr=m(),U=t("div"),_(be.$$.fragment),Yo=m(),hr=t("p"),Ko=n("Converts unique ID to RGB color."),Kr=m(),C=t("div"),_(ve.$$.fragment),Qo=m(),q=t("p"),Xo=n("Normalizes "),ur=t("code"),Zo=n("image"),et=n(" using the mean and standard deviation specified by "),_r=t("code"),rt=n("mean"),ot=n(" and "),br=t("code"),tt=n("std"),at=n("."),st=m(),vr=t("p"),nt=n("image = (image - mean) / std"),Qr=m(),R=t("div"),_(ye.$$.fragment),it=m(),L=t("p"),mt=n("Pads the "),yr=t("code"),ct=n("image"),dt=n(" with the specified (height, width) "),$r=t("code"),lt=n("padding"),pt=n(" and "),xr=t("code"),gt=n("mode"),ft=n("."),Xr=m(),V=t("div"),_($e.$$.fragment),ht=m(),Ir=t("p"),ut=n("Converts RGB color to unique ID."),Zr=m(),W=t("div"),_(xe.$$.fragment),_t=m(),J=t("p"),bt=n("Rescales "),wr=t("code"),vt=n("image"),yt=n(" by "),Pr=t("code"),$t=n("scale"),xt=n("."),eo=m(),B=t("div"),_(Ie.$$.fragment),It=m(),H=t("p"),wt=n("Resizes "),Er=t("code"),Pt=n("image"),Et=n(" to (h, w) specified by "),Tr=t("code"),Tt=n("size"),Dt=n(" using the PIL library."),ro=m(),G=t("div"),_(we.$$.fragment),kt=m(),Pe=t("p"),Mt=n("Converts "),Dr=t("code"),zt=n("image"),Ct=n(` to a PIL Image. Optionally rescales it and puts the channel dimension back as the last axis if
needed.`),oo=m(),Y=t("h2"),Z=t("a"),kr=t("span"),_(Ee.$$.fragment),qt=m(),Mr=t("span"),Lt=n("ImageProcessingMixin"),to=m(),u=t("div"),_(Te.$$.fragment),jt=m(),zr=t("p"),Nt=n(`This is an image processor mixin used to provide saving/loading functionality for sequential and image feature
extractors.`),Ot=m(),ee=t("div"),_(De.$$.fragment),At=m(),ke=t("p"),St=n("Instantiates a type of "),Be=t("a"),Ft=n("ImageProcessingMixin"),Ut=n(" from a Python dictionary of parameters."),Rt=m(),re=t("div"),_(Me.$$.fragment),Vt=m(),ze=t("p"),Wt=n("Instantiates a image processor of type "),He=t("a"),Jt=n("ImageProcessingMixin"),Bt=n(` from the path to a JSON
file of parameters.`),Ht=m(),N=t("div"),_(Ce.$$.fragment),Gt=m(),qe=t("p"),Yt=n("Instantiate a type of "),Ge=t("a"),Kt=n("ImageProcessingMixin"),Qt=n(" from an image processor."),Xt=m(),_(oe.$$.fragment),Zt=m(),te=t("div"),_(Le.$$.fragment),ea=m(),j=t("p"),ra=n("From a "),Cr=t("code"),oa=n("pretrained_model_name_or_path"),ta=n(`, resolve to a dictionary of parameters, to be used for instantiating a
image processor of type `),qr=t("code"),aa=n("~image_processor_utils.ImageProcessingMixin"),sa=n(" using "),Lr=t("code"),na=n("from_dict"),ia=n("."),ma=m(),O=t("div"),_(je.$$.fragment),ca=m(),Ne=t("p"),da=n(`Upload the image processor file to the \u{1F917} Model Hub while synchronizing a local clone of the repo in
`),jr=t("code"),la=n("repo_path_or_name"),pa=n("."),ga=m(),_(ae.$$.fragment),fa=m(),A=t("div"),_(Oe.$$.fragment),ha=m(),Ae=t("p"),ua=n(`Register this class with a given auto class. This should only be used for custom image processors as the ones
in the library are already mapped with `),Nr=t("code"),_a=n("AutoImageProcessor "),ba=n("."),va=m(),_(se.$$.fragment),ya=m(),ne=t("div"),_(Se.$$.fragment),$a=m(),K=t("p"),xa=n("Save an image processor object to the directory "),Or=t("code"),Ia=n("save_directory"),wa=n(`, so that it can be re-loaded using the
`),Ye=t("a"),Pa=n("from_pretrained()"),Ea=n(" class method."),Ta=m(),ie=t("div"),_(Fe.$$.fragment),Da=m(),Ar=t("p"),ka=n("Serializes this instance to a Python dictionary."),Ma=m(),me=t("div"),_(Ue.$$.fragment),za=m(),Sr=t("p"),Ca=n("Save this instance to a JSON file."),qa=m(),ce=t("div"),_(Re.$$.fragment),La=m(),Fr=t("p"),ja=n("Serializes this instance to a JSON string."),this.h()},l(r){const d=qs('[data-svelte="svelte-1phssyn"]',document.head);f=a(d,"META",{name:!0,content:!0}),d.forEach(o),T=c(r),I=a(r,"H1",{class:!0});var Ve=s(I);h=a(Ve,"A",{id:!0,class:!0,href:!0});var Ur=s(h);D=a(Ur,"SPAN",{});var Rr=s(D);b(l.$$.fragment,Rr),Rr.forEach(o),Ur.forEach(o),E=c(Ve),sr=a(Ve,"SPAN",{});var Oa=s(sr);Do=i(Oa,"Utilities for Image Processors"),Oa.forEach(o),Ve.forEach(o),Vr=c(r),We=a(r,"P",{});var Aa=s(We);ko=i(Aa,`This page lists all the utility functions used by the image processors, mainly the functional
transformations used to process the images.`),Aa.forEach(o),Wr=c(r),Je=a(r,"P",{});var Sa=s(Je);Mo=i(Sa,"Most of those are only useful if you are studying the code of the image processors in the library."),Sa.forEach(o),Jr=c(r),S=a(r,"H2",{class:!0});var so=s(S);X=a(so,"A",{id:!0,class:!0,href:!0});var Fa=s(X);nr=a(Fa,"SPAN",{});var Ua=s(nr);b(fe.$$.fragment,Ua),Ua.forEach(o),Fa.forEach(o),zo=c(so),ir=a(so,"SPAN",{});var Ra=s(ir);Co=i(Ra,"Image Transformations"),Ra.forEach(o),so.forEach(o),Br=c(r),F=a(r,"DIV",{class:!0});var no=s(F);b(he.$$.fragment,no),qo=c(no),k=a(no,"P",{});var de=s(k);Lo=i(de,"Crops the "),mr=a(de,"CODE",{});var Va=s(mr);jo=i(Va,"image"),Va.forEach(o),No=i(de," to the specified "),cr=a(de,"CODE",{});var Wa=s(cr);Oo=i(Wa,"size"),Wa.forEach(o),Ao=i(de,` using a center crop. Note that if the image is too small to be cropped to
the size given, it will be padded (so the returned result will always be of size `),dr=a(de,"CODE",{});var Ja=s(dr);So=i(Ja,"size"),Ja.forEach(o),Fo=i(de,")."),de.forEach(o),no.forEach(o),Hr=c(r),M=a(r,"DIV",{class:!0});var Ke=s(M);b(ue.$$.fragment,Ke),Uo=c(Ke),lr=a(Ke,"P",{});var Ba=s(lr);Ro=i(Ba,"Converts bounding boxes from center format to corners format."),Ba.forEach(o),Vo=c(Ke),pr=a(Ke,"P",{});var Ha=s(pr);Wo=i(Ha,`center format: contains the coordinate for the center of the box and its width, height dimensions
(center_x, center_y, width, height)
corners format: contains the coodinates for the top-left and bottom-right corners of the box
(top_left_x, top_left_y, bottom_right_x, bottom_right_y)`),Ha.forEach(o),Ke.forEach(o),Gr=c(r),z=a(r,"DIV",{class:!0});var Qe=s(z);b(_e.$$.fragment,Qe),Jo=c(Qe),gr=a(Qe,"P",{});var Ga=s(gr);Bo=i(Ga,"Converts bounding boxes from corners format to center format."),Ga.forEach(o),Ho=c(Qe),fr=a(Qe,"P",{});var Ya=s(fr);Go=i(Ya,`corners format: contains the coodinates for the top-left and bottom-right corners of the box
(top_left_x, top_left_y, bottom_right_x, bottom_right_y)
center format: contains the coordinate for the center of the box and its the width, height dimensions
(center_x, center_y, width, height)`),Ya.forEach(o),Qe.forEach(o),Yr=c(r),U=a(r,"DIV",{class:!0});var io=s(U);b(be.$$.fragment,io),Yo=c(io),hr=a(io,"P",{});var Ka=s(hr);Ko=i(Ka,"Converts unique ID to RGB color."),Ka.forEach(o),io.forEach(o),Kr=c(r),C=a(r,"DIV",{class:!0});var Xe=s(C);b(ve.$$.fragment,Xe),Qo=c(Xe),q=a(Xe,"P",{});var le=s(q);Xo=i(le,"Normalizes "),ur=a(le,"CODE",{});var Qa=s(ur);Zo=i(Qa,"image"),Qa.forEach(o),et=i(le," using the mean and standard deviation specified by "),_r=a(le,"CODE",{});var Xa=s(_r);rt=i(Xa,"mean"),Xa.forEach(o),ot=i(le," and "),br=a(le,"CODE",{});var Za=s(br);tt=i(Za,"std"),Za.forEach(o),at=i(le,"."),le.forEach(o),st=c(Xe),vr=a(Xe,"P",{});var es=s(vr);nt=i(es,"image = (image - mean) / std"),es.forEach(o),Xe.forEach(o),Qr=c(r),R=a(r,"DIV",{class:!0});var mo=s(R);b(ye.$$.fragment,mo),it=c(mo),L=a(mo,"P",{});var pe=s(L);mt=i(pe,"Pads the "),yr=a(pe,"CODE",{});var rs=s(yr);ct=i(rs,"image"),rs.forEach(o),dt=i(pe," with the specified (height, width) "),$r=a(pe,"CODE",{});var os=s($r);lt=i(os,"padding"),os.forEach(o),pt=i(pe," and "),xr=a(pe,"CODE",{});var ts=s(xr);gt=i(ts,"mode"),ts.forEach(o),ft=i(pe,"."),pe.forEach(o),mo.forEach(o),Xr=c(r),V=a(r,"DIV",{class:!0});var co=s(V);b($e.$$.fragment,co),ht=c(co),Ir=a(co,"P",{});var as=s(Ir);ut=i(as,"Converts RGB color to unique ID."),as.forEach(o),co.forEach(o),Zr=c(r),W=a(r,"DIV",{class:!0});var lo=s(W);b(xe.$$.fragment,lo),_t=c(lo),J=a(lo,"P",{});var Ze=s(J);bt=i(Ze,"Rescales "),wr=a(Ze,"CODE",{});var ss=s(wr);vt=i(ss,"image"),ss.forEach(o),yt=i(Ze," by "),Pr=a(Ze,"CODE",{});var ns=s(Pr);$t=i(ns,"scale"),ns.forEach(o),xt=i(Ze,"."),Ze.forEach(o),lo.forEach(o),eo=c(r),B=a(r,"DIV",{class:!0});var po=s(B);b(Ie.$$.fragment,po),It=c(po),H=a(po,"P",{});var er=s(H);wt=i(er,"Resizes "),Er=a(er,"CODE",{});var is=s(Er);Pt=i(is,"image"),is.forEach(o),Et=i(er," to (h, w) specified by "),Tr=a(er,"CODE",{});var ms=s(Tr);Tt=i(ms,"size"),ms.forEach(o),Dt=i(er," using the PIL library."),er.forEach(o),po.forEach(o),ro=c(r),G=a(r,"DIV",{class:!0});var go=s(G);b(we.$$.fragment,go),kt=c(go),Pe=a(go,"P",{});var fo=s(Pe);Mt=i(fo,"Converts "),Dr=a(fo,"CODE",{});var cs=s(Dr);zt=i(cs,"image"),cs.forEach(o),Ct=i(fo,` to a PIL Image. Optionally rescales it and puts the channel dimension back as the last axis if
needed.`),fo.forEach(o),go.forEach(o),oo=c(r),Y=a(r,"H2",{class:!0});var ho=s(Y);Z=a(ho,"A",{id:!0,class:!0,href:!0});var ds=s(Z);kr=a(ds,"SPAN",{});var ls=s(kr);b(Ee.$$.fragment,ls),ls.forEach(o),ds.forEach(o),qt=c(ho),Mr=a(ho,"SPAN",{});var ps=s(Mr);Lt=i(ps,"ImageProcessingMixin"),ps.forEach(o),ho.forEach(o),to=c(r),u=a(r,"DIV",{class:!0});var w=s(u);b(Te.$$.fragment,w),jt=c(w),zr=a(w,"P",{});var gs=s(zr);Nt=i(gs,`This is an image processor mixin used to provide saving/loading functionality for sequential and image feature
extractors.`),gs.forEach(o),Ot=c(w),ee=a(w,"DIV",{class:!0});var uo=s(ee);b(De.$$.fragment,uo),At=c(uo),ke=a(uo,"P",{});var _o=s(ke);St=i(_o,"Instantiates a type of "),Be=a(_o,"A",{href:!0});var fs=s(Be);Ft=i(fs,"ImageProcessingMixin"),fs.forEach(o),Ut=i(_o," from a Python dictionary of parameters."),_o.forEach(o),uo.forEach(o),Rt=c(w),re=a(w,"DIV",{class:!0});var bo=s(re);b(Me.$$.fragment,bo),Vt=c(bo),ze=a(bo,"P",{});var vo=s(ze);Wt=i(vo,"Instantiates a image processor of type "),He=a(vo,"A",{href:!0});var hs=s(He);Jt=i(hs,"ImageProcessingMixin"),hs.forEach(o),Bt=i(vo,` from the path to a JSON
file of parameters.`),vo.forEach(o),bo.forEach(o),Ht=c(w),N=a(w,"DIV",{class:!0});var rr=s(N);b(Ce.$$.fragment,rr),Gt=c(rr),qe=a(rr,"P",{});var yo=s(qe);Yt=i(yo,"Instantiate a type of "),Ge=a(yo,"A",{href:!0});var us=s(Ge);Kt=i(us,"ImageProcessingMixin"),us.forEach(o),Qt=i(yo," from an image processor."),yo.forEach(o),Xt=c(rr),b(oe.$$.fragment,rr),rr.forEach(o),Zt=c(w),te=a(w,"DIV",{class:!0});var $o=s(te);b(Le.$$.fragment,$o),ea=c($o),j=a($o,"P",{});var ge=s(j);ra=i(ge,"From a "),Cr=a(ge,"CODE",{});var _s=s(Cr);oa=i(_s,"pretrained_model_name_or_path"),_s.forEach(o),ta=i(ge,`, resolve to a dictionary of parameters, to be used for instantiating a
image processor of type `),qr=a(ge,"CODE",{});var bs=s(qr);aa=i(bs,"~image_processor_utils.ImageProcessingMixin"),bs.forEach(o),sa=i(ge," using "),Lr=a(ge,"CODE",{});var vs=s(Lr);na=i(vs,"from_dict"),vs.forEach(o),ia=i(ge,"."),ge.forEach(o),$o.forEach(o),ma=c(w),O=a(w,"DIV",{class:!0});var or=s(O);b(je.$$.fragment,or),ca=c(or),Ne=a(or,"P",{});var xo=s(Ne);da=i(xo,`Upload the image processor file to the \u{1F917} Model Hub while synchronizing a local clone of the repo in
`),jr=a(xo,"CODE",{});var ys=s(jr);la=i(ys,"repo_path_or_name"),ys.forEach(o),pa=i(xo,"."),xo.forEach(o),ga=c(or),b(ae.$$.fragment,or),or.forEach(o),fa=c(w),A=a(w,"DIV",{class:!0});var tr=s(A);b(Oe.$$.fragment,tr),ha=c(tr),Ae=a(tr,"P",{});var Io=s(Ae);ua=i(Io,`Register this class with a given auto class. This should only be used for custom image processors as the ones
in the library are already mapped with `),Nr=a(Io,"CODE",{});var $s=s(Nr);_a=i($s,"AutoImageProcessor "),$s.forEach(o),ba=i(Io,"."),Io.forEach(o),va=c(tr),b(se.$$.fragment,tr),tr.forEach(o),ya=c(w),ne=a(w,"DIV",{class:!0});var wo=s(ne);b(Se.$$.fragment,wo),$a=c(wo),K=a(wo,"P",{});var ar=s(K);xa=i(ar,"Save an image processor object to the directory "),Or=a(ar,"CODE",{});var xs=s(Or);Ia=i(xs,"save_directory"),xs.forEach(o),wa=i(ar,`, so that it can be re-loaded using the
`),Ye=a(ar,"A",{href:!0});var Is=s(Ye);Pa=i(Is,"from_pretrained()"),Is.forEach(o),Ea=i(ar," class method."),ar.forEach(o),wo.forEach(o),Ta=c(w),ie=a(w,"DIV",{class:!0});var Po=s(ie);b(Fe.$$.fragment,Po),Da=c(Po),Ar=a(Po,"P",{});var ws=s(Ar);ka=i(ws,"Serializes this instance to a Python dictionary."),ws.forEach(o),Po.forEach(o),Ma=c(w),me=a(w,"DIV",{class:!0});var Eo=s(me);b(Ue.$$.fragment,Eo),za=c(Eo),Sr=a(Eo,"P",{});var Ps=s(Sr);Ca=i(Ps,"Save this instance to a JSON file."),Ps.forEach(o),Eo.forEach(o),qa=c(w),ce=a(w,"DIV",{class:!0});var To=s(ce);b(Re.$$.fragment,To),La=c(To),Fr=a(To,"P",{});var Es=s(Fr);ja=i(Es,"Serializes this instance to a JSON string."),Es.forEach(o),To.forEach(o),w.forEach(o),this.h()},h(){p(f,"name","hf:doc:metadata"),p(f,"content",JSON.stringify(Fs)),p(h,"id","utilities-for-image-processors"),p(h,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(h,"href","#utilities-for-image-processors"),p(I,"class","relative group"),p(X,"id","transformers.image_transforms.center_crop"),p(X,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(X,"href","#transformers.image_transforms.center_crop"),p(S,"class","relative group"),p(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(B,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(G,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(Z,"id","transformers.ImageProcessingMixin"),p(Z,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(Z,"href","#transformers.ImageProcessingMixin"),p(Y,"class","relative group"),p(Be,"href","/docs/transformers/main/en/internal/image_processing_utils#transformers.ImageProcessingMixin"),p(ee,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(He,"href","/docs/transformers/main/en/internal/image_processing_utils#transformers.ImageProcessingMixin"),p(re,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(Ge,"href","/docs/transformers/main/en/internal/image_processing_utils#transformers.ImageProcessingMixin"),p(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(te,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(Ye,"href","/docs/transformers/main/en/internal/image_processing_utils#transformers.ImageProcessingMixin.from_pretrained"),p(ne,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(me,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(ce,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(u,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(r,d){e(document.head,f),g(r,T,d),g(r,I,d),e(I,h),e(h,D),v(l,D,null),e(I,E),e(I,sr),e(sr,Do),g(r,Vr,d),g(r,We,d),e(We,ko),g(r,Wr,d),g(r,Je,d),e(Je,Mo),g(r,Jr,d),g(r,S,d),e(S,X),e(X,nr),v(fe,nr,null),e(S,zo),e(S,ir),e(ir,Co),g(r,Br,d),g(r,F,d),v(he,F,null),e(F,qo),e(F,k),e(k,Lo),e(k,mr),e(mr,jo),e(k,No),e(k,cr),e(cr,Oo),e(k,Ao),e(k,dr),e(dr,So),e(k,Fo),g(r,Hr,d),g(r,M,d),v(ue,M,null),e(M,Uo),e(M,lr),e(lr,Ro),e(M,Vo),e(M,pr),e(pr,Wo),g(r,Gr,d),g(r,z,d),v(_e,z,null),e(z,Jo),e(z,gr),e(gr,Bo),e(z,Ho),e(z,fr),e(fr,Go),g(r,Yr,d),g(r,U,d),v(be,U,null),e(U,Yo),e(U,hr),e(hr,Ko),g(r,Kr,d),g(r,C,d),v(ve,C,null),e(C,Qo),e(C,q),e(q,Xo),e(q,ur),e(ur,Zo),e(q,et),e(q,_r),e(_r,rt),e(q,ot),e(q,br),e(br,tt),e(q,at),e(C,st),e(C,vr),e(vr,nt),g(r,Qr,d),g(r,R,d),v(ye,R,null),e(R,it),e(R,L),e(L,mt),e(L,yr),e(yr,ct),e(L,dt),e(L,$r),e($r,lt),e(L,pt),e(L,xr),e(xr,gt),e(L,ft),g(r,Xr,d),g(r,V,d),v($e,V,null),e(V,ht),e(V,Ir),e(Ir,ut),g(r,Zr,d),g(r,W,d),v(xe,W,null),e(W,_t),e(W,J),e(J,bt),e(J,wr),e(wr,vt),e(J,yt),e(J,Pr),e(Pr,$t),e(J,xt),g(r,eo,d),g(r,B,d),v(Ie,B,null),e(B,It),e(B,H),e(H,wt),e(H,Er),e(Er,Pt),e(H,Et),e(H,Tr),e(Tr,Tt),e(H,Dt),g(r,ro,d),g(r,G,d),v(we,G,null),e(G,kt),e(G,Pe),e(Pe,Mt),e(Pe,Dr),e(Dr,zt),e(Pe,Ct),g(r,oo,d),g(r,Y,d),e(Y,Z),e(Z,kr),v(Ee,kr,null),e(Y,qt),e(Y,Mr),e(Mr,Lt),g(r,to,d),g(r,u,d),v(Te,u,null),e(u,jt),e(u,zr),e(zr,Nt),e(u,Ot),e(u,ee),v(De,ee,null),e(ee,At),e(ee,ke),e(ke,St),e(ke,Be),e(Be,Ft),e(ke,Ut),e(u,Rt),e(u,re),v(Me,re,null),e(re,Vt),e(re,ze),e(ze,Wt),e(ze,He),e(He,Jt),e(ze,Bt),e(u,Ht),e(u,N),v(Ce,N,null),e(N,Gt),e(N,qe),e(qe,Yt),e(qe,Ge),e(Ge,Kt),e(qe,Qt),e(N,Xt),v(oe,N,null),e(u,Zt),e(u,te),v(Le,te,null),e(te,ea),e(te,j),e(j,ra),e(j,Cr),e(Cr,oa),e(j,ta),e(j,qr),e(qr,aa),e(j,sa),e(j,Lr),e(Lr,na),e(j,ia),e(u,ma),e(u,O),v(je,O,null),e(O,ca),e(O,Ne),e(Ne,da),e(Ne,jr),e(jr,la),e(Ne,pa),e(O,ga),v(ae,O,null),e(u,fa),e(u,A),v(Oe,A,null),e(A,ha),e(A,Ae),e(Ae,ua),e(Ae,Nr),e(Nr,_a),e(Ae,ba),e(A,va),v(se,A,null),e(u,ya),e(u,ne),v(Se,ne,null),e(ne,$a),e(ne,K),e(K,xa),e(K,Or),e(Or,Ia),e(K,wa),e(K,Ye),e(Ye,Pa),e(K,Ea),e(u,Ta),e(u,ie),v(Fe,ie,null),e(ie,Da),e(ie,Ar),e(Ar,ka),e(u,Ma),e(u,me),v(Ue,me,null),e(me,za),e(me,Sr),e(Sr,Ca),e(u,qa),e(u,ce),v(Re,ce,null),e(ce,La),e(ce,Fr),e(Fr,ja),ao=!0},p(r,[d]){const Ve={};d&2&&(Ve.$$scope={dirty:d,ctx:r}),oe.$set(Ve);const Ur={};d&2&&(Ur.$$scope={dirty:d,ctx:r}),ae.$set(Ur);const Rr={};d&2&&(Rr.$$scope={dirty:d,ctx:r}),se.$set(Rr)},i(r){ao||(y(l.$$.fragment,r),y(fe.$$.fragment,r),y(he.$$.fragment,r),y(ue.$$.fragment,r),y(_e.$$.fragment,r),y(be.$$.fragment,r),y(ve.$$.fragment,r),y(ye.$$.fragment,r),y($e.$$.fragment,r),y(xe.$$.fragment,r),y(Ie.$$.fragment,r),y(we.$$.fragment,r),y(Ee.$$.fragment,r),y(Te.$$.fragment,r),y(De.$$.fragment,r),y(Me.$$.fragment,r),y(Ce.$$.fragment,r),y(oe.$$.fragment,r),y(Le.$$.fragment,r),y(je.$$.fragment,r),y(ae.$$.fragment,r),y(Oe.$$.fragment,r),y(se.$$.fragment,r),y(Se.$$.fragment,r),y(Fe.$$.fragment,r),y(Ue.$$.fragment,r),y(Re.$$.fragment,r),ao=!0)},o(r){$(l.$$.fragment,r),$(fe.$$.fragment,r),$(he.$$.fragment,r),$(ue.$$.fragment,r),$(_e.$$.fragment,r),$(be.$$.fragment,r),$(ve.$$.fragment,r),$(ye.$$.fragment,r),$($e.$$.fragment,r),$(xe.$$.fragment,r),$(Ie.$$.fragment,r),$(we.$$.fragment,r),$(Ee.$$.fragment,r),$(Te.$$.fragment,r),$(De.$$.fragment,r),$(Me.$$.fragment,r),$(Ce.$$.fragment,r),$(oe.$$.fragment,r),$(Le.$$.fragment,r),$(je.$$.fragment,r),$(ae.$$.fragment,r),$(Oe.$$.fragment,r),$(se.$$.fragment,r),$(Se.$$.fragment,r),$(Fe.$$.fragment,r),$(Ue.$$.fragment,r),$(Re.$$.fragment,r),ao=!1},d(r){o(f),r&&o(T),r&&o(I),x(l),r&&o(Vr),r&&o(We),r&&o(Wr),r&&o(Je),r&&o(Jr),r&&o(S),x(fe),r&&o(Br),r&&o(F),x(he),r&&o(Hr),r&&o(M),x(ue),r&&o(Gr),r&&o(z),x(_e),r&&o(Yr),r&&o(U),x(be),r&&o(Kr),r&&o(C),x(ve),r&&o(Qr),r&&o(R),x(ye),r&&o(Xr),r&&o(V),x($e),r&&o(Zr),r&&o(W),x(xe),r&&o(eo),r&&o(B),x(Ie),r&&o(ro),r&&o(G),x(we),r&&o(oo),r&&o(Y),x(Ee),r&&o(to),r&&o(u),x(Te),x(De),x(Me),x(Ce),x(oe),x(Le),x(je),x(ae),x(Oe),x(se),x(Se),x(Fe),x(Ue),x(Re)}}}const Fs={local:"utilities-for-image-processors",sections:[{local:"transformers.image_transforms.center_crop",title:"Image Transformations"},{local:"transformers.ImageProcessingMixin",title:"ImageProcessingMixin"}],title:"Utilities for Image Processors"};function Us(Q){return Ls(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Gs extends Ms{constructor(f){super();zs(this,f,Us,Ss,Cs,{})}}export{Gs as default,Fs as metadata};
